/**
 * $Id: AdminListAction.java,v 1.1 2006/03/21 12:01:20 cvs Exp $
 * 쌠:       Copyright (c) 2006 ASKA Systems,Ltd. All right reserved.<p>
 * Ж:       ASKA Systems,Ltd.<p>
 */
package com.askasystems.MailAdmin;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.actions.DispatchAction;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.struts.validator.DynaValidatorForm;

/**
 * Ǘ҃OCAction <BR>
 * 
 * @author Yasuhiro Yamamoto
 * @version 0.1
 */
public class AdminListAction extends DispatchAction {

	static GateKeeper pGateKeeper_;

	static DomainManager pDomainManager_;
	
	static Logger pLogger_ ;

	public ActionForward in(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		DynaValidatorForm aLForm = (DynaValidatorForm) form;
		String sDomain = aLForm.getString("domain");

		HttpSession session = request.getSession();
		Ticket ticket = (Ticket) session.getAttribute("ticket");

		if (ticket == null)
			throw new SessionException();

		if (!ticket.isActive()
				|| (!ticket.isAdmin() && !ticket.getDomain().equals(sDomain)))
			throw new PermissionException();
		
		Ticket ticketNull = new Ticket() ;
		ticketNull.pSDomain = sDomain ;

		session.setAttribute("null_admin", ticketNull);
		session.setAttribute("admins", pGateKeeper_
				.getAdminList(sDomain));

		return mapping.findForward("admin_list");

	}

	public ActionForward add(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		HttpSession session = request.getSession();
	
		DynaValidatorForm aLForm = (DynaValidatorForm) form;
		String sId = aLForm.getString("id");
		String sDomain = aLForm.getString("domain");

		if (pGateKeeper_.Exists(sId, sDomain)) {

			ActionMessages actionMessages = new ActionMessages();
			actionMessages.add(ActionMessages.GLOBAL_MESSAGE,
					new ActionMessage("errors.conflict", "ǗID"));
			saveErrors(request, actionMessages);
			return mapping.findForward("admin_list");
		}

		Ticket ticketTarget = new Ticket();
		ticketTarget.pSId = sId;
		ticketTarget.pSDomain = sDomain;
		ticketTarget.pBIsGhost = true;

		session.setAttribute("target_ticket", ticketTarget);

		return mapping.findForward("change_password");

	}

	public ActionForward delete(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		HttpSession session = request.getSession();
		Ticket ticket = (Ticket) session.getAttribute("ticket");

		DynaValidatorForm aMForm = (DynaValidatorForm) form;
		String sId = aMForm.getString("id");
		String sDomain = aMForm.getString("domain");

		if (ticket == null)
			throw new SessionException();

		if (!ticket.isActive()
				|| (!ticket.isAdmin() && !ticket.getDomain().equals(sDomain)))
			throw new PermissionException();

		pGateKeeper_.removeAdmin(sId, sDomain);
		
		pLogger_.log(ticket,"Delete Admin", sId + "@" + sDomain) ;

		session.setAttribute("admins", pGateKeeper_
				.getAdminList(sDomain));

		return mapping.findForward("admin_list");
	}

}
