/**
 * $Id: AdminMenuAction.java,v 1.2.2.2 2006/07/11 17:57:14 cvs Exp $
 * 쌠:       Copyright (c) 2006 ASKA Systems,Ltd. All right reserved.<p>
 * Ж:       ASKA Systems,Ltd.<p>
 */
package com.askasystems.MailAdmin;

import java.util.regex.Pattern;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;
import org.apache.struts.validator.DynaValidatorForm;

public class AdminMenuAction extends DispatchAction {

	static GateKeeper pGateKeeper_;

	static DomainManager pDomainManager_;

	static MailboxManager pMailboxManager_;

	static boolean pBQuota_;

	private Pattern pvPattern = Pattern.compile("\\d+");

	public ActionForward in(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		DynaValidatorForm aMForm = (DynaValidatorForm) form;
		String sDomain = aMForm.getString("domain");

		HttpSession session = request.getSession();
		Ticket ticket = (Ticket) session.getAttribute("ticket");

		if (ticket == null)
			throw new SessionException();

		if (!ticket.isActive()
				|| (!ticket.isAdmin() && !ticket.getDomain().equals(sDomain)))
			throw new PermissionException();

		HelpInfo helpInfo = new HelpInfo();
		DomainInfo domainInfo = null;
		if (sDomain.equals("")) {
			domainInfo = (DomainInfo) session.getAttribute("domain_info");
		} else {
			domainInfo = pDomainManager_.getDomainInfo(sDomain);
		}
		helpInfo.pSPrefix = domainInfo.getPrefix();
		helpInfo.pSSuffix = domainInfo.getSuffix();
		if (domainInfo.isAdmin()) {
			helpInfo.pSSampleAddress = "";
		} else {
			helpInfo.pSSampleAddress = "@" + domainInfo.getDomain();
		}

		if (pBQuota_) {
			int[] nAmount = QuotaManager.setMailboxesUsed(pMailboxManager_
					.getMailboxList(domainInfo.getDomain()));
			QuotaManager.setDomainUsedString(domainInfo, nAmount);
		}

		session.setAttribute("domain_info", domainInfo);
		session.setAttribute("help_info", helpInfo);

		return mapping.findForward("admin_menu");
	}

	public ActionForward changePassword(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		HttpSession session = request.getSession();
		Ticket ticket = (Ticket) session.getAttribute("ticket");
		session.setAttribute("target_ticket", ticket);

		return mapping.findForward("change_password");

	}

	public ActionForward updateDomain(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		DynaValidatorForm aMForm = (DynaValidatorForm) form;
		String sDomain = aMForm.getString("domain");
		String sDescription = aMForm.getString("description");
		String sQuota = aMForm.getString("quotaString");
		int nQuota = -1;
		if (pvPattern.matcher(sQuota).matches()) {
			nQuota = Integer.parseInt(sQuota);
		}

		HttpSession session = request.getSession();
		Ticket ticket = (Ticket) session.getAttribute("ticket");

		if (ticket == null)
			throw new SessionException();

		if (!ticket.isActive()
				|| (!ticket.isAdmin() && !ticket.getDomain().equals(sDomain)))
			throw new PermissionException();

		pDomainManager_.updateDomain(sDomain, sDescription, nQuota);

		DomainInfo domainInfo = pDomainManager_.getDomainInfo(sDomain);
		if (pBQuota_) {
			int[] nAmount = QuotaManager.setMailboxesUsed(pMailboxManager_
					.getMailboxList(sDomain));
			QuotaManager.setDomainUsedString(domainInfo, nAmount);
		}

		session.setAttribute("domain_info", domainInfo);

		return mapping.findForward("admin_menu");

	}

}
