/**
 * $Id: AliasesAction.java,v 1.1.2.1 2006/07/11 17:57:14 cvs Exp $
 * 쌠:       Copyright (c) 2006 ASKA Systems,Ltd. All right reserved.<p>
 * Ж:       ASKA Systems,Ltd.<p>
 */
package com.askasystems.MailAdmin;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.actions.DispatchAction;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.struts.validator.DynaValidatorForm;

import java.util.List;

/**
 * AliasesAction <BR>
 * 
 * @author Yasuhiro Yamamoto
 * @version 0.1
 */
public class AliasesAction extends DispatchAction {

	static AliasesManager pAliasesManager_;

	static Logger pLogger_;
	
	public ActionForward in(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		HttpSession session = request.getSession();
		Ticket ticket = (Ticket) session.getAttribute("ticket");

		if (ticket == null)
			throw new SessionException();

		if (!ticket.isActive() || !ticket.isAdmin())
			throw new PermissionException();

		List<AliasInfo> lAliases = pAliasesManager_.getAliasList();

		session.setAttribute("aliases", lAliases);

		return mapping.findForward("aliases");

	}

	public ActionForward add(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		HttpSession session = request.getSession();
		Ticket ticket = (Ticket) session.getAttribute("ticket");

		if (ticket == null)
			throw new SessionException();

		if (!ticket.isActive() || !ticket.isAdmin())
			throw new PermissionException();
		
		DynaValidatorForm aForm = (DynaValidatorForm) form;
		String sUser = aForm.getString("user");
		String sDestination = aForm.getString("destination");
		
		if (pAliasesManager_.Exists(sUser)) {

			ActionMessages actionMessages = new ActionMessages();
			actionMessages.add(ActionMessages.GLOBAL_MESSAGE,
					new ActionMessage("errors.conflict", "[U"));
			saveErrors(request, actionMessages);
			return mapping.findForward("aliases");
		}

		pAliasesManager_.addAlias(sUser, sDestination);		
		pLogger_.log(ticket, "add Alias", sUser);
		
		List<AliasInfo> lAliases = pAliasesManager_.getAliasList();
		session.setAttribute("aliases", lAliases);

		return mapping.findForward("aliases");

	}

	public ActionForward update(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		HttpSession session = request.getSession();
		Ticket ticket = (Ticket) session.getAttribute("ticket");

		if (ticket == null)
			throw new SessionException();

		if (!ticket.isActive() || !ticket.isAdmin())
			throw new PermissionException();
		
		DynaValidatorForm aForm = (DynaValidatorForm) form;
		String sUser = aForm.getString("user");
		String sDestination = aForm.getString("destination");

		pAliasesManager_.updateAlias(sUser, sDestination);
		pLogger_.log(ticket, "update Alias", sUser);

		List<AliasInfo> lAliases = pAliasesManager_.getAliasList();
		session.setAttribute("aliases", lAliases);

		return mapping.findForward("aliases");

	}

	public ActionForward delete(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		HttpSession session = request.getSession();
		Ticket ticket = (Ticket) session.getAttribute("ticket");

		if (ticket == null)
			throw new SessionException();

		if (!ticket.isActive() || !ticket.isAdmin())
			throw new PermissionException();
		
		DynaValidatorForm aForm = (DynaValidatorForm) form;
		String sUser = aForm.getString("user");

		pAliasesManager_.removeAlias(sUser);
		pLogger_.log(ticket, "remove Alias", sUser);
		
		List<AliasInfo> lAliases = pAliasesManager_.getAliasList();
		session.setAttribute("aliases", lAliases);
		
		return mapping.findForward("aliases");
	}


}
