/**
 * $Id: ChangePasswordAction.java,v 1.1 2006/03/21 12:01:20 cvs Exp $
 * 쌠:       Copyright (c) 2006 ASKA Systems,Ltd. All right reserved.<p>
 * Ж:       ASKA Systems,Ltd.<p>
 */
package com.askasystems.MailAdmin;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.Action;
import org.apache.struts.validator.DynaValidatorForm;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * pX[hύXAction <BR>
 * 
 * @author Yasuhiro Yamamoto
 * @version 0.1
 */
public class ChangePasswordAction extends Action {

	static GateKeeper pGateKeeper_;

	static Logger pLogger_;

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		DynaValidatorForm cPForm = (DynaValidatorForm) form;
		String sPass = cPForm.getString("password");

		HttpSession session = request.getSession();
		Ticket ticket = (Ticket) session.getAttribute("ticket");
		Ticket ticketTarget = (Ticket) session.getAttribute("target_ticket");

		if (ticket == null)
			throw new SessionException();

		if (!ticket.isActive()
				|| (!ticket.isAdmin() && !ticket.getDomain().equals(
						ticketTarget.getDomain())))
			throw new PermissionException();

		if (!isCancelled(request)) {

			if (ticketTarget.isGhost()) {

				pGateKeeper_.addAdmin(ticketTarget.getId(), ticketTarget
						.getDomain(), sPass);
				pLogger_.log(ticket, "add Admin", ticketTarget.getId() + "@"
						+ ticketTarget.getDomain());
				session.setAttribute("admins", pGateKeeper_
						.getAdminList(ticketTarget.getDomain()));
			} else {

				pGateKeeper_.changePassword(ticketTarget.getId(), ticketTarget
						.getDomain(), sPass);
				pLogger_.log(ticket, "change Password", ticketTarget.getId()
						+ "@" + ticketTarget.getDomain());
			}
		}

		session.removeAttribute("target_ticket");

		if (ticket.equals(ticketTarget))
			return mapping.findForward("admin_menu");

		return mapping.findForward("admin_list");

	}
}
