/**
 * $Id: DomainListAction.java,v 1.1.2.1 2006/07/11 17:57:14 cvs Exp $
 * 쌠:       Copyright (c) 2006 ASKA Systems,Ltd. All right reserved.<p>
 * Ж:       ASKA Systems,Ltd.<p>
 */
package com.askasystems.MailAdmin;

import java.util.Iterator;
import java.util.List;
import java.util.regex.Pattern;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.actions.DispatchAction;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.struts.validator.DynaValidatorForm;

/**
 * hCXgAction <BR>
 * 
 * @author Yasuhiro Yamamoto
 * @version 0.1
 */
public class DomainListAction extends DispatchAction {

	static DomainManager pDomainManager_;

	static GateKeeper pGateKeeper_;

	static MailboxManager pMailboxManager_;

	static VirtualMapManager pVirtualMapManager_;

	static boolean pBVirtdomains_;

	static boolean pBQuota_;

	static Logger pLogger_;

	static String pSCyrusImapdAdmin_;

	static int pNSizeLevel1_ = 70;

	static int pNSizeLevel2_ = 90;

	static int pNSizeLevel3_ = 99;

	private Pattern pvPattern = Pattern.compile("\\d+");

	public ActionForward in(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		HttpSession session = request.getSession();
		Ticket ticket = (Ticket) session.getAttribute("ticket");
		if (ticket == null)
			throw new SessionException();
		if (!ticket.isActive() || !ticket.isAdmin())
			throw new PermissionException();

		session.setAttribute("domain_list", setUsed(pDomainManager_
				.getDomainList()));

		return mapping.findForward("domain_list");

	}

	public ActionForward add(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		HttpSession session = request.getSession();
		Ticket ticket = (Ticket) session.getAttribute("ticket");
		if (ticket == null)
			throw new SessionException();
		if (!ticket.isActive() || !ticket.isAdmin())
			throw new PermissionException();

		DynaValidatorForm dLForm = (DynaValidatorForm) form;
		String sDomain = dLForm.getString("domain");

		if (pDomainManager_.Exists(sDomain)) {

			ActionMessages actionMessages = new ActionMessages();
			actionMessages.add(ActionMessages.GLOBAL_MESSAGE,
					new ActionMessage("errors.conflict", "hC"));
			saveErrors(request, actionMessages);
			return mapping.findForward("domain_list");
		}

		String sQuota = dLForm.getString("quota");
		int nQuota = -1;
		if (pvPattern.matcher(sQuota).matches()) {
			nQuota = Integer.parseInt(sQuota);
		}

		if (pBVirtdomains_) {
			pDomainManager_.addDomain(sDomain, dLForm.getString("description"),
					"", "@" + sDomain, nQuota);
		} else {
			pDomainManager_.addDomain(sDomain, dLForm.getString("description"),
					dLForm.getString("prefix"), dLForm.getString("suffix"),
					nQuota);
		}

		pLogger_.log(ticket, "add Domain", sDomain);

		session.setAttribute("domain_list", setUsed(pDomainManager_
				.getDomainList()));

		return mapping.findForward("domain_list");

	}

	public ActionForward delete(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		HttpSession session = request.getSession();
		Ticket ticket = (Ticket) session.getAttribute("ticket");
		if (ticket == null)
			throw new SessionException();
		if (!ticket.isActive() || !ticket.isAdmin())
			throw new PermissionException();

		DynaValidatorForm dLForm = (DynaValidatorForm) form;
		String sDomain = dLForm.getString("domain");

		ActionMessages actionMessages = new ActionMessages();
		int nBoxN = pMailboxManager_.getMailBoxNumber(sDomain) ;
		if (nBoxN == 1 && pMailboxManager_.getMailboxList(sDomain).iterator()
				.next().getId().equals(pSCyrusImapdAdmin_)) {
			pMailboxManager_.removeMailbox(pSCyrusImapdAdmin_) ;
			nBoxN = 0 ;
		}

		if (pGateKeeper_.getAdminNumber(sDomain) > 0) {
			actionMessages.add(ActionMessages.GLOBAL_MESSAGE,
					new ActionMessage("errors.restadmin"));
			saveErrors(request, actionMessages);
		} else if (nBoxN > 0) {
			actionMessages.add(ActionMessages.GLOBAL_MESSAGE,
					new ActionMessage("errors.restbox"));
			saveErrors(request, actionMessages);
		} else if (pVirtualMapManager_.getAddressNumber(sDomain) > 0) {
			actionMessages.add(ActionMessages.GLOBAL_MESSAGE,
					new ActionMessage("errors.restaddress"));
			saveErrors(request, actionMessages);
		} else {

			pDomainManager_.removeDomain(sDomain);

			pLogger_.log(ticket, "delete Domain", sDomain);

			session.setAttribute("domain_list", setUsed(pDomainManager_
					.getDomainList()));

		}

		return mapping.findForward("domain_list");
	}

	public ActionForward changeActive(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		HttpSession session = request.getSession();
		Ticket ticket = (Ticket) session.getAttribute("ticket");
		if (ticket == null)
			throw new SessionException();
		if (!ticket.isActive() || !ticket.isAdmin())
			throw new PermissionException();

		DynaValidatorForm dLForm = (DynaValidatorForm) form;
		String sDomain = dLForm.getString("domain");
		boolean bActive = (Boolean) (dLForm.get("active"));

		if (!pDomainManager_.getDomainInfo(sDomain).isAdmin()) {
			pDomainManager_.changeActive(sDomain, bActive);
		}

		pLogger_.log(ticket, "change Active of Domain", sDomain + " ("
				+ bActive + ")");

		session.setAttribute("domain_list", setUsed(pDomainManager_
				.getDomainList()));

		return mapping.findForward("domain_list");
	}

	private List<DomainInfo> setUsed(List<DomainInfo> listDomain) {

		if (pBQuota_) {

			Iterator<DomainInfo> iDomain = listDomain.iterator();

			while (iDomain.hasNext()) {

				DomainInfo domainInfo = iDomain.next();

				List<MailboxInfo> lsBox = pMailboxManager_
						.getMailboxList(domainInfo.getDomain());

				int[] nAmount = QuotaManager.setMailboxesUsed(lsBox);

				QuotaManager.setDomainUsedString(domainInfo, nAmount);
			}
		}

		return listDomain;
	}

}
