/**
 * $Id: LoginAction.java,v 1.2.2.1 2006/07/11 17:57:14 cvs Exp $
 * 쌠:       Copyright (c) 2006 ASKA Systems,Ltd. All right reserved.<p>
 * Ж:       ASKA Systems,Ltd.<p>
 */
package com.askasystems.MailAdmin;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

/**
 * Ǘ҃OCAction <BR>
 * 
 * @author Yasuhiro Yamamoto
 * @version 0.1
 */
public class LoginAction extends Action {

	static GateKeeper pGateKeeper_;

	static DomainManager pDomainManager_;

	static MailboxManager pMailboxManager_;

	static Logger pLogger_;

	static String pSAdminDomain_;

	static boolean pBQuota_;

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		LoginForm mLForm = (LoginForm) form;

		HttpSession session = request.getSession();

		String sDomain = mLForm.getDomain();
		String sId = mLForm.getId();
		String sPass = mLForm.getPassword();

		Ticket ticket = pGateKeeper_.check(sDomain, sId, sPass);

		if (!ticket.isActive()) {
			pLogger_.log(ticket, "Login", "sF~");
			throw new AuthenticationException();
		}

		pLogger_.log(ticket, "Login", "");

		HelpInfo helpInfo = new HelpInfo();
		DomainInfo domainInfo = pDomainManager_.getDomainInfo(sDomain);
		helpInfo.pSPrefix = domainInfo.getPrefix();
		helpInfo.pSSuffix = domainInfo.getSuffix();
		if (ticket.isAdmin()) {
			helpInfo.pSSampleAddress = "";
		} else {
			helpInfo.pSSampleAddress = "@" + ticket.getDomain();
		}

		if (pBQuota_) {
			int[] nAmount = QuotaManager.setMailboxesUsed(pMailboxManager_
					.getMailboxList(domainInfo.getDomain()));
			QuotaManager.setDomainUsedString(domainInfo, nAmount);
		}

		session.setAttribute("ticket", ticket);
		session.setAttribute("domain_info", domainInfo);
		session.setAttribute("help_info", helpInfo);

		return mapping.findForward("admin_menu");

	}

}
