/**
 * $Id: MailAdminInit.java,v 1.2.2.1 2006/07/11 17:57:14 cvs Exp $
 * 쌠:       Copyright (c) 2004 ASKA Systems,Ltd. All right reserved.<p>
 * Ж:       ASKA Systems,Ltd.<p>
 */
package com.askasystems.MailAdmin;

import java.io.File;
import java.io.FileReader;
import java.io.BufferedReader;

import java.util.LinkedList;
import java.util.Iterator;
import java.util.regex.Pattern;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.sql.DataSource;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.apache.struts.action.ActionServlet;
import org.apache.struts.action.PlugIn;
import org.apache.struts.config.ModuleConfig;

/**
 * NX <BR>
 * 
 * @author Yasuhiro Yamamoto
 * @version 0.1
 */
public class MailAdminInit implements PlugIn {

	private final String KEY_OF_DEFAULT_ADMIN_ID = "default_admin";

	private String pvSDefaultAdminId = "mailadmin";

	private final String KEY_OF_DEFAULT_ADMIN_PASSWORD = "default_password";

	private String pvSDefaultAdminPassword = "mailadmin";

	private final String KEY_OF_ADMIN_DOMAIN = "admin_domain";

	private String pvSAdminDomain = "admin";

	private final String KEY_OF_ADMIN_DESCRIPTION = "admin_description";

	private String pvSAdminDescription = "Ǘ";

	private final String KEY_OF_CYRUS_IMAPD_ADMIN = "cyrus_imapd_admin";

	private String pvSCyrusImapdAdmin = "cyrus";

	private final String KEY_OF_CYRUS_IMAPD_PASSWORD = "cyrus_imapd_password";

	private String pvSCyrusImapdPassword = "cyrus";

	private final String KEY_OF_ADMIN_REALM = "admin_realm";

	private String pvSAdminRealm = "";

	private final String KEY_OF_VIRTDOMAINS = "virtdomains";

	private boolean pvBVirtdomains = false;

	private final String KEY_OF_CYRADM_AGENT = "cyradm_agent";

	private boolean pvBCyradmAgent = false;

	private final String KEY_OF_QUOTA = "quota";

	private boolean pvBQuota = false;

	private final String KEY_OF_DEFAULT_ALIASES_FILE = "default_aliases_file";

	private String pvSDefaultAliasesFile = "WEB-INF/MailAdminConfig/aliases";

	private final String KEY_OF_DATA_SOURCE_NAME = "data_source_name";

	private String pvSDataSourceName = "java:comp/env/jdbc/MailAdmin";

	private ConfigLoadHandler pvCfLoadHandler;

	private GateKeeper pvGateKeeper;

	private DomainManager pvDomainManager;

	private MailboxManager pvMailboxManager;

	private VirtualMapManager pvVirtualMapManager;

	private AliasesManager pvAliasesManager;

	private Logger pvLogger;

	private Pattern pvPattern = Pattern.compile("^\\s.");

	/*
	 * ( Javadoc)
	 * 
	 * @see org.apache.struts.action.PlugIn#destroy()
	 */
	public void destroy() {
		// TODO ꂽ\bhEX^u

	}

	/*
	 * ( Javadoc)
	 * 
	 * @see org.apache.struts.action.PlugIn#init(org.apache.struts.action.ActionServlet,
	 *      org.apache.struts.config.ModuleConfig)
	 */
	public void init(ActionServlet arg0, ModuleConfig arg1)
			throws ServletException {

		ServletContext svContext = arg0.getServletContext();
		File fileConfDir = new File(svContext
				.getRealPath("/WEB-INF/MailAdminConfig/MailAdminConfig.xml"));

		loadConfig(fileConfDir);

		setUpParam();

		DomainInfo.pBVirtdomains_ = pvBVirtdomains;

		DefaultAliasesLoader.pSDefaultAliasesFile_ = pvSDefaultAliasesFile;

		File fileAliases;
		if (pvSDefaultAliasesFile.substring(0, 1).equals("/")) {
			fileAliases = new File(pvSDefaultAliasesFile);
		} else {
			fileAliases = new File(svContext.getRealPath("/"
					+ pvSDefaultAliasesFile));
		}

		String sEngine = pvCfLoadHandler.pHsMapParam.get("engine");
		if (sEngine == null || sEngine.equals("") || sEngine.equals("mysql")) {
			setUpMySQL();
			if (pvAliasesManager.getAliasNumber() == 0) {
				loadDefaultAliases(fileAliases);
			}
		}

		LoginAction.pGateKeeper_ = pvGateKeeper;
		LoginAction.pDomainManager_ = pvDomainManager;
		LoginAction.pMailboxManager_ = pvMailboxManager;
		LoginAction.pLogger_ = pvLogger;
		LoginAction.pSAdminDomain_ = pvSAdminDomain;
		LoginAction.pBQuota_ = pvBQuota;

		AdminMenuAction.pGateKeeper_ = pvGateKeeper;
		AdminMenuAction.pDomainManager_ = pvDomainManager;
		AdminMenuAction.pMailboxManager_ = pvMailboxManager;
		AdminMenuAction.pBQuota_ = pvBQuota;

		AdminListAction.pGateKeeper_ = pvGateKeeper;
		AdminListAction.pDomainManager_ = pvDomainManager;
		AdminListAction.pLogger_ = pvLogger;

		ChangePasswordAction.pGateKeeper_ = pvGateKeeper;
		ChangePasswordAction.pLogger_ = pvLogger;

		DomainListAction.pDomainManager_ = pvDomainManager;
		DomainListAction.pGateKeeper_ = pvGateKeeper;
		DomainListAction.pMailboxManager_ = pvMailboxManager;
		DomainListAction.pVirtualMapManager_ = pvVirtualMapManager;
		DomainListAction.pBVirtdomains_ = pvBVirtdomains;
		DomainListAction.pLogger_ = pvLogger;
		DomainListAction.pBQuota_ = pvBQuota;
		DomainListAction.pSCyrusImapdAdmin_ = pvSCyrusImapdAdmin;

		MailboxListAction.pDomainManager_ = pvDomainManager;
		MailboxListAction.pMailboxManager_ = pvMailboxManager;
		MailboxListAction.pVirtualMapManager_ = pvVirtualMapManager;
		MailboxListAction.pLogger_ = pvLogger;
		MailboxListAction.pBCyradmAgent_ = pvBCyradmAgent;
		MailboxListAction.pBQuota_ = pvBQuota;

		VirtualMapListAction.pMailboxManager_ = pvMailboxManager;
		VirtualMapListAction.pVirtualMapManager_ = pvVirtualMapManager;
		VirtualMapListAction.pDomainManager_ = pvDomainManager;
		VirtualMapListAction.pLogger_ = pvLogger;

		AliasesAction.pAliasesManager_ = pvAliasesManager;
		AliasesAction.pLogger_ = pvLogger;

		LogAction.pDomainManager_ = pvDomainManager;
		LogAction.pLogger_ = pvLogger;

		LogoutAction.pLogger_ = pvLogger;

		MailboxInfo.pSCyrusImapdAdmin_ = pvSCyrusImapdAdmin;

		DomainInfo.pBQuota_ = pvBQuota;

		HelpInfo.pBVirtdomains_ = pvBVirtdomains;
		HelpInfo.pBQuota_ = pvBQuota;

		QuotaManager.pBCyradmAgent_ = pvBCyradmAgent;

		CyradmAgent.pSScriptPath_ = svContext
				.getRealPath("/WEB-INF/script/cyradmagent.pl");

		if (pvDomainManager.noAdmin()) {
			if (pvBVirtdomains) {
				pvDomainManager.addDomain(pvSAdminDomain,
						pvSAdminDescription, "", "@"
								+ pvSAdminDomain, -1);
			} else {
				pvDomainManager.addDomain(pvSAdminDomain,
						pvSAdminDescription, "", "", -1);
			}
		}

		if (pvGateKeeper.getAdminNumber(pvSAdminDomain) == 0) {
			pvGateKeeper.addAdmin(pvSDefaultAdminId, pvSAdminDomain,
					pvSDefaultAdminPassword);
		}

		if (!pvMailboxManager.Exists(pvSCyrusImapdAdmin)) {
			pvMailboxManager.addMailbox(pvSCyrusImapdAdmin,
					pvSCyrusImapdPassword, pvSAdminDomain,
					"Cyrus-imapd Ǘ", -1);
		} else if (!pvMailboxManager.getMailboxInfo(pvSCyrusImapdAdmin)
				.getDomain().equals(pvSAdminDomain)) {
			pvMailboxManager.removeMailbox(pvSCyrusImapdAdmin);
			pvMailboxManager.addMailbox(pvSCyrusImapdAdmin,
					pvSCyrusImapdPassword, pvSAdminDomain,
					"Cyrus-imapd Ǘ", -1);
		}
	}

	private void loadConfig(File file) {

		pvCfLoadHandler = new ConfigLoadHandler();

		try {
			SAXParserFactory sAXParserFactory = SAXParserFactory.newInstance();
			sAXParserFactory.setValidating(true);
			SAXParser sAXParser = sAXParserFactory.newSAXParser();
			sAXParser.parse(file, pvCfLoadHandler);
		} catch (Exception ex) {
			System.out.println("SAXParserG[");
			ex.printStackTrace();
			return;
		}
	}

	private void setUpParam() {

		String sId = pvCfLoadHandler.pHsMapParam.get(KEY_OF_DEFAULT_ADMIN_ID);
		if (sId != null && !sId.equals(""))
			pvSDefaultAdminId = sId;

		String sPass = pvCfLoadHandler.pHsMapParam
				.get(KEY_OF_DEFAULT_ADMIN_PASSWORD);
		if (sPass != null && !sPass.equals(""))
			pvSDefaultAdminPassword = sPass;

		String sDomain = pvCfLoadHandler.pHsMapParam
				.get(KEY_OF_ADMIN_DOMAIN);
		if (sDomain != null && !sDomain.equals(""))
			pvSAdminDomain = sDomain;

		String sDescription = pvCfLoadHandler.pHsMapParam
				.get(KEY_OF_ADMIN_DESCRIPTION);
		if (sDescription != null)
			pvSAdminDescription = sDescription;

		String sImapdAdmin = pvCfLoadHandler.pHsMapParam
				.get(KEY_OF_CYRUS_IMAPD_ADMIN);
		if (sImapdAdmin != null)
			pvSCyrusImapdAdmin = sImapdAdmin;

		String sImapdPassword = pvCfLoadHandler.pHsMapParam
				.get(KEY_OF_CYRUS_IMAPD_PASSWORD);
		if (sImapdPassword != null)
			pvSCyrusImapdPassword = sImapdPassword;

		String sVirtdomains = pvCfLoadHandler.pHsMapParam
				.get(KEY_OF_VIRTDOMAINS);
		if (sVirtdomains != null && sVirtdomains.equals("true"))
			pvBVirtdomains = true;

		String sAdminRealm = pvCfLoadHandler.pHsMapParam
				.get(KEY_OF_ADMIN_REALM);
		if (sAdminRealm != null)
			pvSAdminRealm = sAdminRealm;

		String sCyradmAgent = pvCfLoadHandler.pHsMapParam
				.get(KEY_OF_CYRADM_AGENT);
		if (sCyradmAgent != null && sCyradmAgent.equals("true"))
			pvBCyradmAgent = true;

		String sQuota = pvCfLoadHandler.pHsMapParam.get(KEY_OF_QUOTA);
		if (sQuota != null && sQuota.equals("true"))
			pvBQuota = true;

		String sDefaultAliasesFile = pvCfLoadHandler.pHsMapParam
				.get(KEY_OF_DEFAULT_ALIASES_FILE);
		if (sDefaultAliasesFile != null)
			pvSDefaultAliasesFile = sDefaultAliasesFile;

		String sDataSourceName = pvCfLoadHandler.pHsMapParam
				.get(KEY_OF_DATA_SOURCE_NAME);
		if (sDataSourceName != null)
			pvSDataSourceName = sDataSourceName;

		if (pvBVirtdomains)
			pvSCyrusImapdAdmin += "@" + pvSAdminDomain;
	}

	private void setUpMySQL() {

		try {
			Context context = new InitialContext();
			DataSource dataSource = (DataSource) context
					.lookup(pvSDataSourceName);
			MySQLGateKeeper.pDataSource_ = dataSource;
			MySQLDomainManager.pDataSource_ = dataSource;
			MySQLMailboxManager.pDataSource_ = dataSource;
			MySQLVirtualDomainMailboxManager.pDataSource_ = dataSource;
			MySQLVirtualMapManager.pDataSource_ = dataSource;
			MySQLAliasesManager.pDataSource_ = dataSource;
			MySQLLogger.pDataSource_ = dataSource;
		} catch (Exception ex) {
			System.out.println(ex);
			ex.printStackTrace();
		}

		MySQLDomainManager.pSAdminDomain_ = pvSAdminDomain;
		pvDomainManager = new MySQLDomainManager();

		MySQLGateKeeper.pSAdminDomain_ = pvSAdminDomain;
		pvGateKeeper = new MySQLGateKeeper();

		if (pvBVirtdomains) {
			MySQLVirtualDomainMailboxManager.pSAdminRealm_ = pvSAdminRealm;
			MySQLVirtualDomainMailboxManager.pSAdminDomain_ = pvSAdminDomain;
			pvMailboxManager = new MySQLVirtualDomainMailboxManager();
		} else {
			pvMailboxManager = new MySQLMailboxManager();
		}

		MySQLVirtualMapManager.pMailboxManager_ = pvMailboxManager;
		MySQLVirtualMapManager.pSCyrusImapdAdmin_ = pvSCyrusImapdAdmin;
		pvVirtualMapManager = new MySQLVirtualMapManager();

		pvAliasesManager = new MySQLAliasesManager();

		pvLogger = new MySQLLogger();

		MySQLGateKeeper.pLogger_ = pvLogger;
	}

	private void loadDefaultAliases(File fileAliases) {

		LinkedList<String> lLsLine = new LinkedList<String>();

		try {

			BufferedReader bufReader = new BufferedReader(new FileReader(
					fileAliases));

			String sLine;

			while ((sLine = bufReader.readLine()) != null) {

				if (sLine.equals("") || sLine.startsWith("#"))
					continue;

				if (pvPattern.matcher(sLine).matches()) {
					lLsLine.add(lLsLine.removeLast() + sLine.trim());
				} else {
					lLsLine.add(sLine.trim());
				}
			}
		} catch (Exception ex) {
			System.out.println(ex);
			ex.printStackTrace();
		}

		Iterator<String> iLine = lLsLine.iterator();
		while (iLine.hasNext()) {

			String[] sLine = iLine.next().split(":");
			pvAliasesManager.addAlias(sLine[0].trim(), sLine[1].trim());
		}
	}

}
