/**
 * $Id: MySQLAliasesManager.java,v 1.1.2.1 2006/07/11 17:57:14 cvs Exp $
 * 쌠:       Copyright (c) 2006 ASKA Systems,Ltd. All right reserved.<p>
 * Ж:       ASKA Systems,Ltd.<p>
 */
package com.askasystems.MailAdmin;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;

import javax.sql.DataSource;

public class MySQLAliasesManager implements AliasesManager {

	static DataSource pDataSource_;
	
	public void addAlias(String sUser, String sDestination) {
		
		try {

			Connection con = pDataSource_.getConnection();
			String sSql = "insert into aliases (user, destination, created, modified) values (?, ?, ?, ?)";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sUser);
			st.setString(2, sDestination);
			st.setTimestamp(3, new Timestamp((new java.util.Date().getTime())));
			st.setTimestamp(4, new Timestamp((new java.util.Date().getTime())));
			st.executeUpdate();

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}

	}

	public void removeAlias(String sUser) {

		try {

			Connection con = pDataSource_.getConnection();
			String sSql = "delete from aliases where user = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sUser);
			st.executeUpdate();

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}

	}

	public void updateAlias(String sUser, String sDestination) {

		try {
			Connection con = pDataSource_.getConnection();
			String sSql = "update aliases set destination = ?, modified = ? where user = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sDestination);
			st.setTimestamp(2, new Timestamp((new Date().getTime())));
			st.setString(3, sUser);
			st.executeUpdate();

			st.close();
			con.close();
			
		} catch (SQLException ex) {
			ex.printStackTrace();
		}
		
	}
	
	public List<AliasInfo> getAliasList() {
		
		LinkedList<AliasInfo> lkLsAlias = new LinkedList<AliasInfo>();

		try {

			Connection con = pDataSource_.getConnection();
			String sSql = "select * from aliases order by user";
			PreparedStatement st = con.prepareStatement(sSql);
			ResultSet rtSet = st.executeQuery();

			while (rtSet.next()) {

				AliasInfo aliasInfo = new AliasInfo();

				aliasInfo.pSUser = rtSet.getString("user");
				aliasInfo.pSDestination = rtSet.getString("destination");
				aliasInfo.pDateCreated = rtSet.getTimestamp("created");
				aliasInfo.pDateModified = rtSet.getTimestamp("modified");

				lkLsAlias.add(aliasInfo);
			}

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}

		return lkLsAlias;
	}

	public AliasInfo getAliasInfo(String sUser) {
	
		AliasInfo aliasInfo = null;

		try {

			Connection con = pDataSource_.getConnection();
			String sSql = "select * from aliases where useri = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sUser);
			ResultSet rtSet = st.executeQuery();

			while (rtSet.next()) {

				aliasInfo = new AliasInfo();

				aliasInfo.pSUser = rtSet.getString("user");
				aliasInfo.pSDestination = rtSet.getString("destination");
				aliasInfo.pDateCreated = rtSet.getTimestamp("created");
				aliasInfo.pDateModified = rtSet.getTimestamp("modified");
			}

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}

		return aliasInfo;
	}

	public boolean Exists(String sUser) {

		boolean b = false;

		try {
			Connection con = pDataSource_.getConnection();
			String sSql = "select * from aliases where user = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sUser);
			ResultSet rtSet = st.executeQuery();
			b = rtSet.next();

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}

		return b;
	}

	public int getAliasNumber() {

		int nNumber = 0;

		try {
			Connection con = pDataSource_.getConnection();
			String sSql = "select count(*) from aliases";
			PreparedStatement st = con.prepareStatement(sSql);
			ResultSet rtSet = st.executeQuery();
			rtSet.next();
			nNumber = rtSet.getInt(1);

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}

		return nNumber;
	}

}
