/**
 * $Id: MySQLGateKeeper.java,v 1.1 2006/03/21 12:01:20 cvs Exp $
 * 쌠:       Copyright (c) 2006 ASKA Systems,Ltd. All right reserved.<p>
 * Ж:       ASKA Systems,Ltd.<p>
 */
package com.askasystems.MailAdmin;

import java.security.MessageDigest;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Timestamp;
import javax.sql.DataSource;
import java.util.*;

/**
 * MySQLpǗҔF؃NX <BR>
 * 
 * @author Yasuhiro Yamamoto
 * @version 0.1
 */
public class MySQLGateKeeper implements GateKeeper {

	static DataSource pDataSource_;
	
	static Logger pLogger_;

	static String pSAdminDomain_ ;

	public Ticket check(String sDomain, String sId, String sPassword)
			throws AuthenticationException {

		Ticket ticket = new Ticket();
		ticket.pSId = sId;
		ticket.pSDomain = sDomain;

		try {
			Connection con = pDataSource_.getConnection();

			String sSql = "select * from admins where id = ? and domain = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sId);
			st.setString(2, sDomain);
			ResultSet rtSet = st.executeQuery();

			if (!rtSet.next()
					|| !rtSet.getString("digest").equals(
							encode(sDomain, sId, sPassword))
					|| (!sDomain.equals(pSAdminDomain_) && sPassword.equals(""))) {

				st.close();
				con.close();
				pLogger_.log(ticket,"Login","s") ;
				throw new AuthenticationException();
			}

			ticket.pDateCreated = rtSet.getTimestamp("created");
			ticket.pDateModified = rtSet.getTimestamp("modified");
			if (sDomain.equals(pSAdminDomain_))
				ticket.pBIsAdmin = true;
			if (rtSet.getBoolean("active"))
				ticket.pBIsActive = true;

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}

		return ticket;
	}

	public void changePassword(String sId, String sDomain, String sPassword)
			throws AuthenticationException {

		try {
			Connection con = pDataSource_.getConnection();
			String sSql = "update admins set digest = ?, modified = ? where id = ? and domain = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, encode(sDomain, sId, sPassword));
			st.setTimestamp(2, new Timestamp((new Date().getTime())));
			st.setString(3, sId);
			st.setString(4, sDomain);
			st.executeUpdate();

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}

	}

	public void addAdmin(String sId, String sDomain, String sPassword) {

		try {
			Connection con = pDataSource_.getConnection();
			String sSql = "insert into admins (id, domain, digest, created, modified) values (?, ?, ?, ?, ?)";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sId);
			st.setString(2, sDomain);
			st.setString(3, encode(sDomain, sId, sPassword));
			st.setTimestamp(4, new Timestamp((new Date().getTime())));
			st.setTimestamp(5, new Timestamp((new Date().getTime())));
			st.executeUpdate();

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}
	}

	public void removeAdmin(String sId, String sDomain) {

		try {
			Connection con = pDataSource_.getConnection();
			String sSql = "delete from admins where id = ? and domain = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sId);
			st.setString(2, sDomain);
			st.executeUpdate();

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}
	}

	public void changeActive(String sId, String sDomain, boolean bActive) {

		try {
			Connection con = pDataSource_.getConnection();
			String sSql = "update admins set active = ? modified= ? where id = ? and domain = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setBoolean(1, bActive);
			st.setTimestamp(2, new Timestamp((new Date().getTime())));
			st.setString(3, sId);
			st.setString(4, sDomain);
			st.executeUpdate();

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}
	}
	
	public List<Ticket> getAdminList(String sDomain)  {
		
		LinkedList<Ticket> lkLsAdmin = new LinkedList<Ticket>();
		
		try {
			Connection con = pDataSource_.getConnection();
			String sSql = "select * from admins where domain = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sDomain);
			ResultSet rtSet = st.executeQuery();
			
			while (rtSet.next()) {

				Ticket ticket = new Ticket();

				ticket.pSId = rtSet.getString("id");
				ticket.pSDomain = rtSet.getString("domain");
				ticket.pDateCreated = rtSet.getTimestamp("created");
				ticket.pDateModified = rtSet.getTimestamp("modified");
				if (sDomain.equals(pSAdminDomain_))
					ticket.pBIsAdmin = true;
				if (rtSet.getInt("active") == 1)
					ticket.pBIsActive = true;

				lkLsAdmin.add(ticket);

			}

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}
		
		return lkLsAdmin ;
	}
	
	public List<Ticket> getAbsoluteAdminList() {
		
		return getAdminList(pSAdminDomain_);
	}
	
	public boolean Exists(String sId, String sDomain) {
		
		boolean bExists = false ;
		
		try {
			Connection con = pDataSource_.getConnection();
			String sSql = "select * from admins where id = ? and domain = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sId);
			st.setString(2, sDomain);
			ResultSet rtSet = st.executeQuery();
			
			bExists = rtSet.next() ;

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}
		
		return bExists ;
	}

	public int getAdminNumber(String sDomain) {

		int nNumber = 0;

		try {
			Connection con = pDataSource_.getConnection();
			String sSql = "select count(*) from admins where domain = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sDomain);
			ResultSet rtSet = st.executeQuery();
			rtSet.next();
			nNumber = rtSet.getInt(1);

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}

		return nNumber;
	}

	private String encode(String sDomain, String sId, String sPassword) {

		String sEncode = "";

		try {
			MessageDigest messageDigest = MessageDigest.getInstance("SHA");
			messageDigest.update(sDomain.getBytes("windows-31j"));
			messageDigest.update(sId.getBytes("windows-31j"));
			messageDigest.update(sPassword.getBytes("windows-31j"));
			sEncode = Base64.encode(messageDigest.digest());
		} catch (Exception ex) {
			ex.printStackTrace();
		}

		return sEncode;
	}

}
