/**
 * $Id: MySQLLogger.java,v 1.1 2006/03/21 12:01:20 cvs Exp $
 * 쌠:       Copyright (c) 2006 ASKA Systems,Ltd. All right reserved.<p>
 * Ж:       ASKA Systems,Ltd.<p>
 */
package com.askasystems.MailAdmin;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.Date;
import java.util.List;
import java.util.LinkedList;

import javax.sql.DataSource;

public class MySQLLogger implements Logger {
	
	static DataSource pDataSource_;

	public void log(Ticket ticket, String sAction, String sData) {

		try {

			Connection con = pDataSource_.getConnection();
			String sSql = "insert into log (timestamp, admin, domain, action, data) values (?, ?, ?, ?, ?)";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setTimestamp(1, new Timestamp((new Date().getTime())));
			st.setString(2, ticket.getId());
			st.setString(3, ticket.getDomain());
			st.setString(4, sAction);
			st.setString(5, sData);
			st.executeUpdate();

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}


	}

	public List<Log> getLog(String sDomain, Date dateStart, Date dateEnd) {
		
		LinkedList<Log> lkLsLog = new LinkedList<Log>() ;
		
		try {

			Connection con = pDataSource_.getConnection();
			String sSql = "select * from log where domain = ? and timestamp between ? and ? order by timestamp";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sDomain);
			st.setTimestamp(2, new Timestamp(dateStart.getTime()));
			st.setTimestamp(3, new Timestamp(dateEnd.getTime()));
			ResultSet rtSet = st.executeQuery();

			while (rtSet.next()) {

				Log log = new Log();
				
				log.setTimestamp(rtSet.getTimestamp("timestamp"));
				log.setAdmin(rtSet.getString("admin")) ;
				log.setDomain(rtSet.getString("domain")) ;
				log.setAction(rtSet.getString("action"));
				log.setData(rtSet.getString("data"));
				
				lkLsLog.add(log);

			}

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}

		return lkLsLog;
	}

}
