/**
 * $Id: MySQLVirtualDomainMailboxManager.java,v 1.1.2.1 2006/07/11 17:57:14 cvs Exp $
 * 쌠:       Copyright (c) 2006 ASKA Systems,Ltd. All right reserved.<p>
 * Ж:       ASKA Systems,Ltd.<p>
 */
package com.askasystems.MailAdmin;

import java.util.List;
import java.util.Iterator;

public class MySQLVirtualDomainMailboxManager extends MySQLMailboxManager {

	static String pSAdminDomain_;

	static String pSAdminRealm_;

	public void addMailbox(String sId, String sPassword, String sDomain,
			String sName, int nQuota) {

		super.addMailbox(rewriteId(sId), sPassword, sDomain, sName, nQuota);
	}

	public void removeMailbox(String sId) {

		super.removeMailbox(rewriteId(sId));
	}

	public void updateMailbox(String sId, String sPassword, String sName,
			int nQuota) {

		super.updateMailbox(rewriteId(sId), sPassword, sName, nQuota);
	}

	public void changeActive(String sId, boolean bActive) {

		super.changeActive(rewriteId(sId), bActive);
	}

	public List<MailboxInfo> getMailboxList(String sDomain) {

		List<MailboxInfo> boxes = super.getMailboxList(sDomain);

		if (sDomain.equals(pSAdminDomain_)) {

			Iterator<MailboxInfo> i = boxes.iterator();
			while (i.hasNext()) {

				MailboxInfo boxInfo = i.next();
				boxInfo.pSId = boxInfo.getId().split("@")[0] + "@"
						+ pSAdminDomain_;
			}
		}
		return boxes;
	}

	public MailboxInfo getMailboxInfo(String sId) {

		MailboxInfo boxInfo = super.getMailboxInfo(rewriteId(sId));

		if (boxInfo.getDomain().equals(pSAdminDomain_)) {
			boxInfo.pSId = boxInfo.getId().split("@")[0] + "@"
			+ pSAdminDomain_;
		}

		return boxInfo;
	}

	public boolean Exists(String sId) {

		return super.Exists(rewriteId(sId));
	}

	private String rewriteId(String sId) {

		String[] sIdp = sId.split("@");

		if (sIdp[1].equals(pSAdminDomain_)) {
			sId = sIdp[0] + "@" + pSAdminRealm_;
		}

		return sId;

	}

}
