/**
 * $Id: MySQLVirtualMapManager.java,v 1.1.2.1 2006/07/11 17:57:14 cvs Exp $
 * 쌠:       Copyright (c) 2006 ASKA Systems,Ltd. All right reserved.<p>
 * Ж:       ASKA Systems,Ltd.<p>
 */
package com.askasystems.MailAdmin;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;
import java.util.Iterator;

import javax.sql.DataSource;

public class MySQLVirtualMapManager implements VirtualMapManager {

	static DataSource pDataSource_;

	static MailboxManager pMailboxManager_;

	static String pSCyrusImapdAdmin_;

	public void addAddress(String sMailAddress, String sDomain, String sName,
			String sMailbox) {

		try {

			Connection con = pDataSource_.getConnection();
			String sSql = "insert into virtualmap (address, domain, name, mailboxes, created, modified) values (?, ?, ?, ?, ?, ?)";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sMailAddress);
			st.setString(2, sDomain);
			st.setString(3, sName);
			st.setString(4, sMailbox);
			st.setTimestamp(5, new Timestamp((new Date().getTime())));
			st.setTimestamp(6, new Timestamp((new Date().getTime())));
			st.executeUpdate();

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}

	}

	public void addMailbox(String sMailAddress, String sMailbox) {

		AddressInfo addressInfo = getAddress(sMailAddress);

		// if (!addressInfo.getRestMailboxList().contains(sMailbox)) return ;

		try {
			Connection con = pDataSource_.getConnection();
			String sSql = "update virtualmap set mailboxes = ?,  modified = ? where address = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, addressInfo.getMailboxes() + ", " + sMailbox);
			st.setTimestamp(2, new Timestamp((new Date().getTime())));
			st.setString(3, sMailAddress);
			st.executeUpdate();

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}

	}

	public void removeAddress(String sMailAddress) {

		try {

			Connection con = pDataSource_.getConnection();
			String sSql = "delete from virtualmap where address = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sMailAddress);
			st.executeUpdate();

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}

	}

	public void removeMailbox(String sMailAddress, String sMailbox) {

		String sMailboxes = "";

		AddressInfo addressInfo = getAddress(sMailAddress);
		Iterator<MailboxInfo> iBoxes = addressInfo.getMailboxList().iterator();
		while (iBoxes.hasNext()) {
			String sBox = iBoxes.next().getId();
			if (!sBox.equals(sMailbox))
				sMailboxes += sBox + ", ";
		}

		if (sMailboxes.equals("")) {
			removeAddress(sMailAddress);
			return;
		}

		sMailboxes = sMailboxes.substring(0, sMailboxes.length() - 2);

		try {
			Connection con = pDataSource_.getConnection();
			String sSql = "update virtualmap set mailboxes = ?,  modified = ? where address = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sMailboxes);
			st.setTimestamp(2, new Timestamp((new Date().getTime())));
			st.setString(3, sMailAddress);
			st.executeUpdate();

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}
	}

	public void changeActive(String sMailAddress, boolean bActive) {

		try {
			Connection con = pDataSource_.getConnection();
			String sSql = "update virtualmap set active = ?, modified = ? where address = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setBoolean(1, bActive);
			st.setTimestamp(2, new Timestamp((new Date().getTime())));
			st.setString(3, sMailAddress);
			st.executeUpdate();

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}
	}

	public AddressInfo getAddress(String sMailAddress) {

		AddressInfo addressInfo = new AddressInfo();

		try {

			Connection con = pDataSource_.getConnection();
			String sSql = "select * from virtualmap where address = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sMailAddress);
			ResultSet rtSet = st.executeQuery();

			while (rtSet.next()) {

				addressInfo.pSAddress = rtSet.getString("address");
				addressInfo.pSDomain = rtSet.getString("domain");
				addressInfo.pSName = rtSet.getString("name");
				addressInfo.pBActive = rtSet.getBoolean("active");
				addressInfo.pDateCreated = rtSet.getTimestamp("created");
				addressInfo.pDateModified = rtSet.getTimestamp("modified");
				addressInfo.setMailboxes(rtSet.getString("mailboxes"));

				Iterator<MailboxInfo> i = pMailboxManager_.getMailboxList(
						addressInfo.pSDomain).iterator();
				LinkedList<String> lRestBoxes = new LinkedList<String>();

				while (i.hasNext()) {
					lRestBoxes.add(i.next().getId());
				}
				Iterator<MailboxInfo> im = addressInfo.getMailboxList()
						.iterator();
				while (im.hasNext()) {
					lRestBoxes.remove(im.next().getId());
				}
				lRestBoxes.remove(pSCyrusImapdAdmin_);

				addressInfo.pLsRestMailboxes = lRestBoxes;

			}

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();

		}

		return addressInfo;
	}

	public AddressInfo getNullAddress(String sDomain) {

		AddressInfo addressInfo = new AddressInfo();
		addressInfo.pSDomain = sDomain;

		Iterator<MailboxInfo> i = pMailboxManager_.getMailboxList(sDomain)
				.iterator();
		LinkedList<String> lRestBoxes = new LinkedList<String>();

		while (i.hasNext()) {
			lRestBoxes.add(i.next().getId());
		}
		lRestBoxes.remove(pSCyrusImapdAdmin_);

		addressInfo.pLsRestMailboxes = lRestBoxes;

		return addressInfo;
	}

	public List<AddressInfo> getAddressList(String sDomain) {

		LinkedList<AddressInfo> lkLsAddress = new LinkedList<AddressInfo>();
		List<MailboxInfo> lBoxes = pMailboxManager_.getMailboxList(sDomain);

		try {

			Connection con = pDataSource_.getConnection();
			String sSql = "select * from virtualmap where domain = ? order by address" ;
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sDomain);
			ResultSet rtSet = st.executeQuery();

			while (rtSet.next()) {

				AddressInfo addressInfo = new AddressInfo();

				addressInfo.pSAddress = rtSet.getString("address");
				addressInfo.pSDomain = rtSet.getString("domain");
				addressInfo.pSName = rtSet.getString("name");
				addressInfo.pBActive = rtSet.getBoolean("active");
				addressInfo.pDateCreated = rtSet.getTimestamp("created");
				addressInfo.pDateModified = rtSet.getTimestamp("modified");
				addressInfo.setMailboxes(rtSet.getString("mailboxes"));
				List<String> lRestBoxes = new LinkedList<String>();

				Iterator<MailboxInfo> i = lBoxes.iterator();
				while (i.hasNext()) {
					lRestBoxes.add(i.next().getId());
				}
				Iterator<MailboxInfo> im = addressInfo.getMailboxList()
						.iterator();
				while (im.hasNext()) {
					lRestBoxes.remove(im.next().getId());
				}
				lRestBoxes.remove(pSCyrusImapdAdmin_);

				addressInfo.pLsRestMailboxes = lRestBoxes;

				lkLsAddress.add(addressInfo);
			}

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}

		return lkLsAddress;
	}

	public int getAddressNumber(String sDomain) {

		int nNumber = 0;

		try {
			Connection con = pDataSource_.getConnection();
			String sSql = "select count(*) from virtualmap where domain = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sDomain);
			ResultSet rtSet = st.executeQuery();
			rtSet.next();
			nNumber = rtSet.getInt(1);

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}

		return nNumber;
	}

	public boolean Exists(String sMailAddress) {

		boolean b = false;

		try {
			Connection con = pDataSource_.getConnection();
			String sSql = "select * from virtualmap where address = ?";
			PreparedStatement st = con.prepareStatement(sSql);
			st.setString(1, sMailAddress);
			ResultSet rtSet = st.executeQuery();
			b = rtSet.next();

			st.close();
			con.close();
		} catch (SQLException ex) {
			ex.printStackTrace();
		}

		return b;
	}

}
