/**
 * $Id: QuotaManager.java,v 1.1.2.1 2006/07/11 17:57:14 cvs Exp $
 * 쌠:       Copyright (c) 2006 ASKA Systems,Ltd. All right reserved.<p>
 * Ж:       ASKA Systems,Ltd.<p>
 */
package com.askasystems.MailAdmin;

import java.util.Iterator;
import java.util.List;
import java.util.regex.Pattern;
import java.util.regex.Matcher;

public class QuotaManager {

	static boolean pBCyradmAgent_;

	static int pNSizeLevel1_ = 70;

	static int pNSizeLevel2_ = 90;

	static int pNSizeLevel3_ = 99;

	static private Pattern pvPattern = Pattern.compile("\\[QUOTA:([\\d]*)/\\d*\\]");

	static int setMailboxUsed(MailboxInfo boxInfo) {

		String[] sRes = { "", "" };
		if (pBCyradmAgent_) {

			Matcher matcher = pvPattern.matcher(CyradmAgent.listQuota(boxInfo
					.getId()));
			if (matcher.find()) {
				sRes = matcher.group(1).split("/", 2);
			}
		}

		return setMailboxUsed(boxInfo, sRes[0]).pNUsed;

	}

	static private MailboxInfo setMailboxUsed(MailboxInfo boxInfo, String sRes) {

		if (sRes.equals("")) {
			boxInfo.pSUsed = "H/" + boxInfo.getQuotaString();
			boxInfo.pNUsed = -1;
		} else {
			boxInfo.pNUsed = Integer.parseInt(sRes);
			int nP = 100 * boxInfo.pNUsed / boxInfo.pNQuota;
			boxInfo.pSUsed = sRes + "/" + boxInfo.pNQuota + "(" + nP + "%)";
			if (nP < pNSizeLevel1_) {
				boxInfo.pNSizeLevel = 0;
			} else if (nP < pNSizeLevel2_) {
				boxInfo.pNSizeLevel = 1;
			} else if (nP < pNSizeLevel3_) {
				boxInfo.pNSizeLevel = 2;
			} else {
				boxInfo.pNSizeLevel = 3;
			}
		}

		return boxInfo;

	}

	static int[] setMailboxesUsed(List<MailboxInfo> lsMailboxes) {

		int nUsed = 0;
		int nQuota = 0;
		boolean bUsed = true;
		boolean bQuota = true;

		if (pBCyradmAgent_) {

			String sIds = "";
			Iterator<MailboxInfo> iBoxes = lsMailboxes.iterator();
			while (iBoxes.hasNext()) {
				sIds += iBoxes.next().pSId + " ";
			}
			Matcher matcher = pvPattern.matcher(CyradmAgent.listQuota(sIds));

			int nCount = 0;
			while (matcher.find()) {

				MailboxInfo boxInfo = lsMailboxes.get(nCount);
				setMailboxUsed(boxInfo, matcher.group(1).split("/", 2)[0]);
				if (boxInfo.pNUsed == -1) {
					bUsed = false;
				} else {
					nUsed += boxInfo.pNUsed;
				}

				if (boxInfo.pNQuota == -1) {
					bQuota = false;
				} else {
					nQuota += boxInfo.pNQuota;
				}
				nCount++;
			}
		} else {

			bUsed = false;

			Iterator<MailboxInfo> iBoxes = lsMailboxes.iterator();
			while (iBoxes.hasNext()) {

				MailboxInfo boxInfo = iBoxes.next();

				setMailboxUsed(boxInfo, "");

				if (boxInfo.pNQuota == -1) {
					bQuota = false;
				} else {
					nQuota += boxInfo.pNQuota;
				}
			}
		}

		int[] nAmount = { -1, -1 };

		if (bUsed)
			nAmount[0] = nUsed;

		if (bQuota)
			nAmount[1] = nQuota;

		return nAmount;
	}

	static DomainInfo setDomainUsedString(DomainInfo domainInfo, int[] nAmount) {

		String sUsed = "H";
		String sSize = "";

		if (nAmount[0] > -1) {
			sUsed = String.valueOf(nAmount[0]);
		}

		if (nAmount[1] > -1) {
			sSize = String.valueOf(nAmount[1]);
		}

		if (domainInfo.getQuota() == -1) {

			domainInfo.pSUsed = sUsed + "/" + sSize + "/";
			domainInfo.pNSizeLevel = 0;
		} else {

			if (nAmount[0] > -1 && nAmount[1] > -1) {

				int nP = 100 * nAmount[0] / domainInfo.getQuota();

				domainInfo.pSUsed = sUsed + "/" + sSize + "/"
						+ domainInfo.getQuota() + "(" + nP + "%)";

				if (nP < pNSizeLevel1_) {
					domainInfo.pNSizeLevel = 0;
				} else if (nP < pNSizeLevel2_) {
					domainInfo.pNSizeLevel = 1;
				} else if (nP < pNSizeLevel3_) {
					domainInfo.pNSizeLevel = 2;
				} else {
					domainInfo.pNSizeLevel = 3;
				}

				if (nAmount[1] > domainInfo.getQuota())
					domainInfo.pNSizeLevel = 3;

			} else {

				domainInfo.pSUsed = sUsed + "/" + sSize + "/"
						+ domainInfo.getQuota();
				if (nAmount[1] == -1 || nAmount[1] > domainInfo.getQuota()) {
					domainInfo.pNSizeLevel = 3;
				}
			}

			domainInfo.pNQuotable = domainInfo.getQuota() - nAmount[1];
			if (domainInfo.pNQuotable > 0) {
				domainInfo.pSQuotable = String.valueOf(domainInfo.pNQuotable);
			} else {
				domainInfo.pNQuotable = -2;
				domainInfo.pSQuotable = "s";
			}

		}

		return domainInfo;
	}
}
