/**
 * $Id: VirtualMapListAction.java,v 1.2 2006/04/17 17:16:20 cvs Exp $
 * 쌠:       Copyright (c) 2006 ASKA Systems,Ltd. All right reserved.<p>
 * Ж:       ASKA Systems,Ltd.<p>
 */
package com.askasystems.MailAdmin;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.actions.DispatchAction;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.apache.struts.validator.DynaValidatorForm;

/**
 * Ǘ҃OCAction <BR>
 * 
 * @author Yasuhiro Yamamoto
 * @version 0.1
 */
public class VirtualMapListAction extends DispatchAction {

	static VirtualMapManager pVirtualMapManager_;

	static MailboxManager pMailboxManager_;

	static DomainManager pDomainManager_;

	static Logger pLogger_;

	public ActionForward in(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		DynaValidatorForm vMLForm = (DynaValidatorForm) form;
		String sDomain = vMLForm.getString("domain");

		HttpSession session = request.getSession();
		Ticket ticket = (Ticket) session.getAttribute("ticket");

		if (ticket == null)
			throw new SessionException();

		if (!ticket.isActive()
				|| (!ticket.isAdmin() && !ticket.getDomain().equals(sDomain)))
			throw new PermissionException();

		session.setAttribute("null_address_info", pVirtualMapManager_
				.getNullAddress(sDomain));
		session.setAttribute("addresses", pVirtualMapManager_
				.getAddressList(sDomain));
		session.setAttribute("domain_info", pDomainManager_
				.getDomainInfo(sDomain));

		return mapping.findForward("map_list");

	}

	public ActionForward add(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		DynaValidatorForm vMLForm = (DynaValidatorForm) form;
		String sDomain = vMLForm.getString("domain");
		String sIdBox = vMLForm.getString("id");
		String sIdAddress = vMLForm.getString("id_address");
		String sName = vMLForm.getString("name");
		String sAddress = vMLForm.getString("address");

		HttpSession session = request.getSession();

		Ticket ticket = (Ticket) session.getAttribute("ticket");

		if (ticket == null)
			throw new SessionException();

		if (!ticket.isActive()
				|| (!ticket.isAdmin() && !ticket.getDomain().equals(sDomain)))
			throw new PermissionException();

		if (pVirtualMapManager_.Exists(sAddress)) {

			ActionMessages actionMessages = new ActionMessages();
			actionMessages.add(ActionMessages.GLOBAL_MESSAGE,
					new ActionMessage("errors.conflict", "[AhX"));
			saveErrors(request, actionMessages);
			return mapping.findForward("map_list");
		}

		String sMailboxes = "";
		if (!sIdBox.equals("")) {
			sMailboxes = sIdBox;
			if (!sIdAddress.equals(""))
				sMailboxes += "," + sIdAddress;
		} else {
			sMailboxes = sIdAddress;
		}

		DomainInfo domainInfo = pDomainManager_.getDomainInfo(sDomain);
		if (!sMailboxes.equals("")) {
			if (domainInfo.isAdmin()) {
				if (!sAddress.equals(""))
					pVirtualMapManager_.addAddress(sAddress, sDomain, sName,
							sMailboxes);
			} else {
				pVirtualMapManager_.addAddress(sAddress + "@" + sDomain,
						sDomain, sName, sMailboxes);
			}
		}

		pLogger_.log(ticket, "add Address", sAddress + "@" + sDomain);

		session.setAttribute("null_address_info", pVirtualMapManager_
				.getNullAddress(sDomain));
		session.setAttribute("addresses", pVirtualMapManager_
				.getAddressList(sDomain));
		session.setAttribute("domain_info", domainInfo);

		return mapping.findForward("map_list");

	}

	public ActionForward delete(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		DynaValidatorForm vMLForm = (DynaValidatorForm) form;
		String sDomain = vMLForm.getString("domain");

		HttpSession session = request.getSession();
		Ticket ticket = (Ticket) session.getAttribute("ticket");

		if (ticket == null)
			throw new SessionException();

		if (!ticket.isActive()
				|| (!ticket.isAdmin() && !ticket.getDomain().equals(sDomain)))
			throw new PermissionException();

		String sAddress = vMLForm.getString("address");

		pVirtualMapManager_.removeAddress(sAddress);

		pLogger_.log(ticket, "remove Address", sAddress + "@" + sDomain);

		session.setAttribute("null_address_info", pVirtualMapManager_
				.getNullAddress(sDomain));
		session.setAttribute("addresses", pVirtualMapManager_
				.getAddressList(sDomain));
		session.setAttribute("domain_info", pDomainManager_
				.getDomainInfo(sDomain));

		return mapping.findForward("map_list");
	}

	public ActionForward deleteMailbox(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		DynaValidatorForm vMLForm = (DynaValidatorForm) form;
		String sDomain = vMLForm.getString("domain");

		HttpSession session = request.getSession();
		Ticket ticket = (Ticket) session.getAttribute("ticket");

		if (ticket == null)
			throw new SessionException();

		if (!ticket.isActive()
				|| (!ticket.isAdmin() && !ticket.getDomain().equals(sDomain)))
			throw new PermissionException();

		String sAddress = vMLForm.getString("address");
		String sId = vMLForm.getString("id");

		pVirtualMapManager_.removeMailbox(sAddress, sId);
		pLogger_.log(ticket, "remove Mailbox from Address", sId + "("
				+ sAddress + ")");

		session.setAttribute("null_address_info", pVirtualMapManager_
				.getNullAddress(sDomain));
		session.setAttribute("addresses", pVirtualMapManager_
				.getAddressList(sDomain));
		session.setAttribute("domain_info", pDomainManager_
				.getDomainInfo(sDomain));

		return mapping.findForward("map_list");
	}

	public ActionForward addMailbox(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		DynaValidatorForm vMLForm = (DynaValidatorForm) form;
		String sAddress = vMLForm.getString("address");
		AddressInfo addressInfo = pVirtualMapManager_.getAddress(sAddress);
		String sDomain = addressInfo.getDomain();
		String sIdBox = vMLForm.getString("id");
		String sIdAddress = vMLForm.getString("id_address");

		HttpSession session = request.getSession();

		Ticket ticket = (Ticket) session.getAttribute("ticket");

		if (ticket == null)
			throw new SessionException();

		if (!ticket.isActive()
				|| (!ticket.isAdmin() && !ticket.getDomain().equals(sDomain)))
			throw new PermissionException();

		String sMailboxes = "";
		if (!sIdBox.equals("")) {
			sMailboxes = sIdBox;
			if (!sIdAddress.equals(""))
				sMailboxes += "," + sIdAddress;
		} else {
			sMailboxes = sIdAddress;
		}

		pLogger_.log(ticket, "add Mailbox to Address", sMailboxes + "("
				+ sAddress + ")");
		pVirtualMapManager_.addMailbox(sAddress, sMailboxes);

		session.setAttribute("null_address_info", pVirtualMapManager_
				.getNullAddress(sDomain));
		session.setAttribute("addresses", pVirtualMapManager_
				.getAddressList(sDomain));
		session.setAttribute("domain_info", pDomainManager_
				.getDomainInfo(sDomain));

		return mapping.findForward("map_list");

	}

	public ActionForward changeActive(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		DynaValidatorForm vMLForm = (DynaValidatorForm) form;
		String sAddress = vMLForm.getString("address");
		AddressInfo addressInfo = pVirtualMapManager_.getAddress(sAddress);
		String sDomain = addressInfo.getDomain();
		boolean bActive = (Boolean) (vMLForm.get("active"));

		HttpSession session = request.getSession();

		Ticket ticket = (Ticket) session.getAttribute("ticket");

		if (ticket == null)
			throw new SessionException();

		if (!ticket.isActive()
				|| (!ticket.isAdmin() && !ticket.getDomain().equals(sDomain)))
			throw new PermissionException();

		pVirtualMapManager_.changeActive(sAddress, bActive);
		pLogger_.log(ticket, "change Active of Address", sAddress + " ("
				+ bActive + ")");

		session.setAttribute("null_address_info", pVirtualMapManager_
				.getNullAddress(sDomain));
		session.setAttribute("addresses", pVirtualMapManager_
				.getAddressList(sDomain));
		session.setAttribute("domain_info", pDomainManager_
				.getDomainInfo(sDomain));

		return mapping.findForward("map_list");

	}

}
